#ifndef _CONF_H_
#define _CONF_H_

#include <gconf/gconf.h>
#include "im-ja.h"

typedef struct {
  guint hotkey_states[HOTKEYS_TOTAL];
  guint hotkey_values[HOTKEYS_TOTAL];

	GdkColor preedit_colors[4]; /* preedit string colors: n_fg, n_bg, hl_fg, hl_bg */
	GdkColor original_colors[2]; /* original style: fg and bg */
	gboolean custom_preedit_n;
	gboolean custom_preedit_hl;
	
	gint status_win_position;
	gchar *status_win_labels[IM_JA_INPUT_METHODS_TOTAL];
	gint status_win_coords[2];

	gint default_conv_engine;
  gchar *wnn_address;
	//	gint wnn_port;
	gchar *wnnenvrc;

	gboolean canna_enabled;
	//  gchar *canna_address;
	//	gint canna_port;

	gboolean kanjipad_enabled;
	gboolean kanjipad_custom_size;
	gint kanjipad_size[2];
	
  gint startup_input_method;

} im_ja_cfg;

/* public function prototypes */
int im_ja_init_conf_handler();
int im_ja_finalize_conf_handler(im_ja_cfg *cfg);
int im_ja_load_conf(im_ja_cfg *cfg);
int im_ja_save_conf(im_ja_cfg *cfg);
gchar *get_string_from_color(GdkColor *color);

#endif
