#ifndef _IM_JA_H_
#define _IM_JA_H_

#include <gtk/gtk.h>

#define BUFFERSIZE 1024
#define IM_CONTEXT_JA(obj) (GTK_CHECK_CAST((obj), type_ja, IMContextJA))
#ifndef TYPE_JA_DEFINED
extern GType type_ja;
#endif

//Status widget types
enum {
  STATUS_BELOW_CURSOR,
  STATUS_WINDOW_BOTTOM_LEFT,
  STATUS_FIXED_COORD,
  STATUS_DISABLED
};

enum {
  KANJI_INPUT_CANNA,
  KANJI_INPUT_WNN,
	KANJI_INPUT_TOTAL
	/* TO BE IMPLEMENTED: 
  IM_JA_ANTHY_INPUT ,
  IM_JA_SKK_INPUT,
  IM_JA_ATOK_INPUT,
  IM_JA_XIM_INPUT,
	*/
};

enum {
  IM_JA_RAW_INPUT,
  IM_JA_HIRAGANA_INPUT,
  IM_JA_KATAKANA_INPUT,
  IM_JA_HALFKATA_INPUT,
  IM_JA_ZENKAKU_INPUT,
	IM_JA_KANJI_INPUT,
  IM_JA_KANJIPAD_INPUT,
	
  IM_JA_INPUT_METHODS_TOTAL

  /* TO BE IMPLEMENTED: 
  IM_JA_SYMBOL_INPUT,
  IM_JA_HEX_INPUT,
  IM_JA_TOROKU_INPUT,
  IM_JA_BUSHU_INPUT
  */
};

// Keys
enum {
  START_CONFIGURATOR,
  NEXT_INPUT_MODE,
  PREV_INPUT_MODE,
  RAW_INPUT_MODE,
  HIRAGANA_INPUT_MODE,
  KATAKANA_INPUT_MODE,
  HALFKATA_INPUT_MODE,
  ZENKAKU_INPUT_MODE,
  CANNA_INPUT_MODE,
  WNN_INPUT_MODE,
	KANJI_INPUT_MODE,
  KANJIPAD_INPUT_MODE,
  UNCONVERT,
  CONVERT,
  PREV_CANDIDATE,
  NEXT_CANDIDATE,
  LIST_CANDIDATES,
  PREV_BUNSETSU,
  NEXT_BUNSETSU,
  EXPAND_BUNSETSU,
  SHRINK_BUNSETSU,
  HOTKEYS_TOTAL
};

typedef struct _IMContextJA IMContextJA;

#ifndef DISABLE_WNN
#include "wnn.h"
#endif

struct _IMContextJA {
  struct _GtkIMContext parent;
  GdkWindow *client_window;
	GdkWindow *toplevel;
  GtkWidget *status_window;
  GtkWidget *status_label;
  GtkWidget *status_border;
  GtkWidget *candwin;
  GtkWidget *kanjipad;
	gint cursor_pos_offset_x;
	gint cursor_pos_offset_y;
	gint candwin_pos_offset_x;
	gint candwin_pos_offset_y;
	gboolean update_candwin_pos;

  GList *candidate_list;
  gboolean show_first;
  gboolean status_window_focus_out_disabled;
  gboolean kanjipad_focus_out_disabled;

  /* Preedit string */
  gchar *preedit_buf;
  gchar *preedit_insert;
  gint preedit_reverse_start;
  gint preedit_reverse_end;

  gchar *kakutei_buf;
 
  gint cursor_ndx;
	gint cursor_wnn;

  int cand_stat;
  gboolean show_candidates;
#ifndef DISABLE_WNN
  wnnStat wnn_stat;
#endif
  gint input_method;
  void *canna_rk_ctx;

  void (*on_reset)( IMContextJA *context );

};

/* Function prototypes */

void im_ja_show_status_window(IMContextJA *context);
void im_ja_hide_status_window(IMContextJA *context);
void im_ja_next_input_method(IMContextJA *context);
void im_ja_prev_input_method(IMContextJA *context);
gboolean im_ja_set_input_method(IMContextJA *context, int input_method);
void im_ja_hide_candwin(IMContextJA* context);
void im_ja_show_candwin(IMContextJA *context, int selected);
void im_ja_show_kanjipad(IMContextJA *context);
void im_ja_hide_kanjipad(IMContextJA *context);
void im_ja_reset(IMContextJA *context);
void im_ja_set_preedit_string(IMContextJA *context, gchar *str, gint reverse_start, gint reverse_end);
void im_ja_free_candidate_list(IMContextJA *context);


#endif
